#include <iostream>
#include <cmath>
using namespace std;

//	regular function; can calculate just sin(n_1)
double free_function(double x) {
	return sin(x);
}

//	Functor can preserve a state in a member field...
class Functor {

public:
	explicit Functor(double scale) : scale{scale} {}

//	operator() turns your object into Functor.
	double operator()(double x) const { return sin(scale * x); }

private:
	double scale;
};

int main() {
	cout.setf(ios::fixed, ios::floatfield);	//	set fixed notation
	cout.precision(1);
	double x{M_PI / 6.};
	cout << "sin(Pi/6)   = " << free_function(x) << endl;
	cout << "sin(Pi/6)   = " << Functor(1.0)(x) << endl;
	cout << "sin(3*Pi/6) = " << Functor(3.0)(x) << endl;
	cout << "sin(7*Pi/6) = " << Functor(7.0)(x) << endl;

	return EXIT_SUCCESS;
}

