#include <iostream>
#include <vector>
#include "../includes/random_generator.h"
using namespace std;

class StringArray {

public:
	explicit StringArray(const vector<string> &s) : string_array{s} {}

	string *operator->() {
		return &string_array[randomize::random_int(0, (int)string_array.size() - 1)];
	}

	string operator[](int i) const { return string_array[i]; }

private:
	vector<string> string_array;
};

int main () {

	StringArray string_array({"one", "two", "three", "four"}); // initializer_list
	//	string.data() - direct access to the underlying null-terminated sequence
	//	of characters (C-style char array)
	for (int i = 0; i < 15; i++) {
		cout << string_array->data() << endl;
	}
	return 0;
}

